/*
 * DPOS.c
 *
 * Created: 6/12/2017 2:47:33 am
 * Author : Dimitrios Porlidas
 */ 

#include "LCD_keyb_ROT.h"

int main(void)
{
	_delay_ms(100);

	Initkeyb ();											// Initialize keyboard 4x4
	InitLCD ();												// Initialize LCD 16x2 or 20x4
	InitROT ();												// Initialize ROT (type of rot: detents = pulses)
	USART_Init(34);											// Clock 8MHz: 51->9600, 34->14400, 25->19200, 16->28800*, 12->38400, 8->57600, 6->76800, 3->115200** (*Error magnitude)

    while (1) 
    {
		CountROT ();
		Keyb ();											// Check keyboard
		if (bit_is_set(entry,0))							// If button pressed
		{
			_delay_ms(5);
			if (data == 'C')								// Clear display with C
			{
				WrIn (CDRC);
				_delay_ms (5);
			}
			else if (data != 'C')							// Display character in LCD
			{
				WrDa (data);
				USART_Transmit (data);
			}
			entry &= ~(1<<0);								// Clear entry flag
		}
		if (bit_is_set(entry,1))							// If USART data received
		{
			WrDa (rsdata);									// Send data to LCD
			entry &= ~(1<<1);								// Clear entry flag
		}
    }
}
